Entities = {}
Entities.objects = {}
Register = {}
local id = 0

function Entities.startup()
	Register['player'] = love.filesystem.load( 'entities/player.lua' )
	--weapons
	Register['shuriken'] = love.filesystem.load( 'entities/weapons/shuriken.lua' )
	--enemies
	Register['cat'] = love.filesystem.load( 'entities/enemies/cat.lua' )
end

function Entities.create( name, x, y, ... )
	local e = {}
	
	if Register[name] then
		id = id + 1
		local ent = Register[name]()
		ent.properties = ... 
		ent:create( x, y, ent.properties )
		ent.type = name
		ent.id = id
		Entities.objects[id] = ent
		return Entities.objects[id]
	else
		error( 'make sure that you\'ve registered the entity \''..name..'\' correctly! :)' )
		return false
	end
	
	return e
end

function Entities.draw()
	for i, entity in ipairs( Entities.objects ) do
		entity:draw()
	end
end

function Entities.update(dt)
	for i, entity in ipairs( Entities.objects ) do
		entity:update(dt)
		if entity.collides_ground then
			for ii, tile in ipairs( Tiles.layers ) do
				if ii == 1 then
					Tiles:collide( entity, tile )
				end
			end
		elseif entity.weapon then
			for ii, Ent in ipairs( Entities.objects ) do
				if Ent.ai then
					if entity.x + entity.w >= Ent.x and
					entity.x <= Ent.x + Ent.tile_w and
					entity.y - entity.h >= Ent.y and
					entity.y <= Ent.y + Ent.tile_h then
						Ent.health = Ent.health - entity.damage
						print(Ent.health)
					end
				end
			end
		end
	end
end

function Entities.move()
	for i, entity in ipairs( Entities.objects ) do
		if entity.controlled then
			if love.keyboard.isDown( 'right' ) or love.keyboard.isDown( 'd' ) then
				entity:right()
			end
			if love.keyboard.isDown( 'left' ) or love.keyboard.isDown( 'a' ) then
				entity:left()
			end
			if love.keyboard.isDown( 'up' ) or love.keyboard.isDown( 'w' ) then
				entity:up()
			end		
		end
	end
end

function Entities.stop( key )
	for i, entity in ipairs( Entities.objects ) do
		if key == ' ' then
			if entity.controlled then
				entity:attack()
			end
		elseif entity.controlled then
			entity:stop()
		end
	end
end