--[[
Copyright (c) 2013 Davis Claiborne

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

Basically, please feel free to modify it, but at least let me know! :) I would love to know what people do with it! :)
]]

require 'entities'
require 'maps/tiles'
require 'camera'
require 'levels/level_1'

level = 0

function love.load()
	level = level + 1
	gamestate = level
	if gamestate == 1 then
		load_level_1()
	end
end

function love.draw()
	camera:set()
	
	--Tiles
	Tiles:draw()
	--Entities
	Entities:draw()

	camera:unset()
end

function love.update(dt)
	Entities:update(dt)
	Entities.move()
end

function love.keypressed( key )
	if key == 'escape' then
		love.event.quit()
	end
end

function love.keyreleased( key )
	Entities.stop( key )
end